# -*- coding: utf-8 -*-

from Products.ZCTextIndex.ISplitter import ISplitter
from Products.ZCTextIndex.PipelineFactory import element_factory

import MeCab


# arguments passed to mecab
mecab_arglist = ['mecab','-Owakati']

class MeCabAdaptor(object):
	"""
	wrapper of MeCab::Tagger
	"""
	def __init__(self):
		#self.set()
		self.adaptor = MeCab.Tagger('-Owakati')

	def set(self):
		#self.mecab_adaptor_type = 'mecab'
		#self.adaptor = MeCab.Tagger(mecab_arglist)
		#self.adaptor = MeCab.Tagger(r'--node-format="%m",%ps,%pe,%F-[0,1,2,3]\n')
		#self.adaptor = MeCab.Tagger('-Owakati')
		pass

	def parse(self, txt):
		parsed = ''
		#self.adaptor.lock()
		parsed = self.adaptor.parse(txt)
		#self.adaptor.unlock()
		words = parsed.split()
		words = (w for w in words if w)
		return words

class MTJSplitter(object):
	"""
	MTJSplitter
	Mecab-based Japanese Splitter
	"""
	__implements__ = ISplitter

	mecabAdaptor = MeCabAdaptor()

	def process(self, text, glob=0):
		txt = ' '.join(text)
		return self.mecabAdaptor.parse(txt)

element_factory.registerFactory('Word Splitter', 'MTJSplitter', MTJSplitter)
